use super::{Param, Sequence};
use crate::point::Point;
use opencv::{core::Mat, Result};

#[derive(Debug, Clone, Copy)]
pub struct SaveImage {
    finished: bool,
}

impl SaveImage {
    pub fn new() -> SaveImage {
        SaveImage { finished: true }
    }
}

impl Sequence for SaveImage {
    fn draw(&self, _mem: &Param) -> Option<Vec<Point>> {
        if self.finished {
            return None;
        }
        Some(vec![])
    }
    fn compute_sequence(&mut self, mem: &mut Param) -> Result<(), Box<dyn std::error::Error>> {
        mem.save_image()?;
        self.finished = true;
        Ok(())
    }
    fn is_capture(&self) -> bool {
        false
    }
}
